SystemOrganization addCategory: #'TopFeeder-Model'!

GRObject subclass: #TFCase
	instanceVariableNames: 'title link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

TFCase subclass: #TFBlog
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

TFBlog subclass: #TFAtomBlog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFAtomBlog methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:55'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'feed';
		yourself! !

!TFAtomBlog methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 12:58'!
itemsDescription
	<magritteDescription>
	^ super itemsDescription
		reference: TFAtomItem new magritteDescription;
		beXmlInlineElement;
		yourself! !

!TFAtomBlog methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 12:59'!
linkDescription
	<magritteDescription>
	^ super linkDescription
		beXmlChildAttribute;
		xmlElementName: 'link';
		xmlAttributeName: 'href';
		yourself! !

!TFBlog methodsFor: 'converting' stamp: 'pmm 6/27/2007 09:38'!
convertToWithConverter: aConverter
	super convertToWithConverter: aConverter.
	self items do: [ :each |
		each convertToWithConverter: aConverter ]! !

!TFBlog methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:54'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'channel';
		yourself! !

!TFBlog methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 13:49'!
items
	^ items ifNil: [ items := #() ]! !

!TFBlog methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:29'!
items: aCollection 
	items := aCollection! !

!TFBlog methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:20'!
itemsDescription
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #items;
		label: 'Items';
		priority: 300;
		reference: TFBlogItem new magritteDescription;
		beXmlInlineElement;
		yourself! !

!TFBlog methodsFor: 'converting' stamp: 'NickAger 3/26/2012 13:50'!
toUtf8
	self convertToWithConverter: (TextConverter newForEncoding: #utf8)! !

TFCase subclass: #TFBlogItem
	instanceVariableNames: 'textualDescription authorString content pubDate tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

TFBlogItem subclass: #TFAtomItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFAtomItem methodsFor: 'accessing' stamp: 'lr 8/6/2008 10:17'!
content: aString
	| read |
	super content: aString.
	aString ifNil: [ ^ self textualDescription: nil ].
	read := aString readStream.
	self textualDescription: (String streamContents: [ :write |
		[ read atEnd ] whileFalse: [
			write nextPutAll: (read upTo: $<).
			read upTo: $> ] ])! !

!TFAtomItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:01'!
contentDescription
	<magritteDescription>
	^ super contentDescription
		xmlElementName: 'content';
		yourself! !

!TFAtomItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:56'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'entry';
		yourself! !

!TFAtomItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:02'!
linkDescription
	<magritteDescription>
	^ TFAtomBlog new linkDescription! !

!TFAtomItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:02'!
pubDateDescription
	<magritteDescription>
	^ super pubDateDescription 
		xmlElementName: 'updated';
		yourself! !

!TFAtomItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:02'!
textualDescriptionDescription
	<magritteDescription>
	^ nil! !

!TFBlogItem methodsFor: 'comparing' stamp: 'pmm 3/17/2007 18:23'!
<= other
	^self pubDate > other pubDate! !

!TFBlogItem methodsFor: 'accessing' stamp: 'NickAger 3/24/2012 08:30'!
author
	| username address |
	self authorString isEmptyOrNil
		ifTrue: [ ^nil ].
	(self authorString includes: $<)
		ifFalse: [ ^nil ].
	username := self authorString copyUpTo: $<.
	address := (self authorString copyAfter: $<) allButLast.
	^ WAEmailAddress
		address: address
		username: username! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 12:59'!
authorDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #authorString;
		label: 'Author';
		priority: 300;
		xmlElementName: 'author';
		yourself! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/29/2012 07:41'!
authorDescription2
	<magritteDescription>
	^ MAStringDescription new
		accessor: #authorString;
		label: 'Author';
		priority: 300;
		xmlElementName: 'dc:creator';
		yourself! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/27/2007 22:23'!
authorString
	^authorString! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/27/2007 22:23'!
authorString: aString 
	authorString := aString! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/27/2007 22:31'!
content
	^content! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/27/2007 22:31'!
content: aString 
	content := aString! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:00'!
contentDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #content;
		label: 'Content';
		priority: 500;
		xmlElementName: 'content:encoded';
		yourself! !

!TFBlogItem methodsFor: 'converting' stamp: 'lr 5/18/2009 20:53'!
convertToWithConverter: aConverter
	super convertToWithConverter: aConverter.
	self textualDescription: ((self textualDescription ifNil: [ String new ]) convertToWithConverter: aConverter)! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:55'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'item';
		yourself! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 3/17/2007 16:08'!
pubDate
	^pubDate! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:29'!
pubDate: aTimestamp 
	pubDate := aTimestamp! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/29/2012 18:04'!
pubDateDescription
	<magritteDescription>
	^ MATimeStampDescription new
		accessor: #pubDate;
		label: 'Publication Date';
		priority: 150;
		stringReader: TFRfc2822TimeStampReader;
		stringWriter: TFRfc2822TimeStampWriter;
		beXmlElement;
		yourself! !

!TFBlogItem methodsFor: 'testing' stamp: 'pmm 12/3/2007 20:29'!
satisfiesAnyKeyword: aCollectionOfStrings
	^aCollectionOfStrings isEmptyOrNil
		or: [ aCollectionOfStrings anySatisfy: [ :each |
			(self textualDescription includesSubstring: each caseSensitive: false)
				or: [ self content notNil
					and: [ self content includesSubstring: each caseSensitive: false ] ] ] ]! !

!TFBlogItem methodsFor: 'accessing' stamp: 'NickAger 3/29/2012 11:59'!
tags
	^ tags! !

!TFBlogItem methodsFor: 'accessing' stamp: 'NickAger 3/29/2012 11:59'!
tags: anObject
	tags := anObject! !

!TFBlogItem methodsFor: 'accessing' stamp: 'NickAger 3/29/2012 17:54'!
tagsDescription
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #tags;
		xmlElementName: 'category';
		yourself
! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 3/17/2007 16:08'!
textualDescription
	^textualDescription! !

!TFBlogItem methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:30'!
textualDescription: aString 
	textualDescription := aString! !

!TFBlogItem methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:01'!
textualDescriptionDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #textualDescription;
		label: 'Description';
		priority: 400;
		xmlElementName: 'description';
		yourself! !

!TFCase methodsFor: 'converting' stamp: 'pmm 6/27/2007 09:39'!
convertToWithConverter: aConverter
	self title: (self title convertToWithConverter: aConverter)! !

!TFCase methodsFor: 'accessing' stamp: 'pmm 3/17/2007 22:05'!
link
	^link! !

!TFCase methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:30'!
link: aUrl 
	link := aUrl! !

!TFCase methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 14:06'!
linkDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #link;
		label: 'Link';
		priority: 200;
		beXmlElement;
		yourself! !

!TFCase methodsFor: 'printing' stamp: 'pmm 3/17/2007 22:20'!
printOn: aStream
	super printOn: aStream.
	self title isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self title;
			nextPut: $) ]! !

!TFCase methodsFor: 'accessing' stamp: 'pmm 3/17/2007 22:04'!
title
	^title! !

!TFCase methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:30'!
title: aString 
	title := aString! !

!TFCase methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 12:57'!
titleDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		label: 'Title';
		priority: 100;
		beXmlElement;
		yourself! !

GRObject subclass: #TFFeedUpdater
	instanceVariableNames: 'url feedReadTimeAssociation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFFeedUpdater class methodsFor: 'defaults' stamp: 'NickAger 3/26/2012 12:41'!
maxAge
	^ 1 day! !

!TFFeedUpdater class methodsFor: 'instance creation' stamp: 'NickAger 3/26/2012 12:18'!
url: aFeedUrl
	^ self new
		url: aFeedUrl;
		yourself! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 13:13'!
feed
	^ self feedReadTimeAssociation key! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 13:16'!
feed: feed
	feedReadTimeAssociation := feed -> TimeStamp now! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 13:13'!
feedReadTimeAssociation
	^ feedReadTimeAssociation ifNil: [ 
		feedReadTimeAssociation := TFRss new -> TimeStamp unixEpoch ]! !

!TFFeedUpdater methodsFor: 'testing' stamp: 'NickAger 3/26/2012 13:13'!
isTooOld
	^ self lastUpdate isNil
		or: [ TimeStamp now - self lastUpdate > self class maxAge ]! !

!TFFeedUpdater methodsFor: 'testing' stamp: 'NickAger 3/26/2012 13:14'!
lastUpdate
	^ self feedReadTimeAssociation value! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 13:14'!
readTime: time
	self feedReadTimeAssociation value: time! !

!TFFeedUpdater methodsFor: 'actions' stamp: 'NickAger 3/26/2012 13:15'!
update
	self isTooOld ifTrue: [
		[ self updateWithTimeout ]
			on: XMLParserException, TFCreationException, NameLookupFailure
			do: [ self readTime: TimeStamp now ] ]! !

!TFFeedUpdater methodsFor: 'actions' stamp: 'NickAger 3/26/2012 13:15'!
updateWithTimeout
	 [ | updatedFeed |
	updatedFeed := TFRssReaderFactory fromUrl: self url.
	self feed: updatedFeed ]
		valueWithin: 20 seconds
		onTimeout: [ 
			self readTime: TimeStamp now.
			Transcript show: 'TIMEOUT: '; show: self url; cr ]! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 12:18'!
url
	^ url! !

!TFFeedUpdater methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 12:18'!
url: anObject
	url := anObject! !

GRObject subclass: #TFRss
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFRss methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 12:24'!
blog
	^ blog! !

!TFRss methodsFor: 'accessing' stamp: 'pmm 6/23/2007 02:14'!
blog: aBlog 
	blog := aBlog! !

!TFRss methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:53'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'rss';
		yourself! !

!TFRss methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 12:44'!
items
	^ self blog items! !

!TFRss methodsFor: 'accessing-description' stamp: 'NickAger 3/26/2012 13:19'!
itemsDescription
	<magritteDescription>
	^ MAToOneRelationDescription new
		selectorAccessor: #blog;
		label: 'Blog';
		priority: 100;
		reference: TFBlog new magritteDescription;
		beXmlInlineElement;
		yourself! !

!TFRss methodsFor: 'printing' stamp: 'pmm 3/19/2007 09:46'!
printOn: aStream
	super printOn: aStream.
	(self blog notNil and: [ self blog title notNil ]) ifTrue: [
		aStream
			nextPut: $(;
			nextPutAll: self blog title;
			nextPut: $) ]! !

!TFRss methodsFor: 'converting' stamp: 'NickAger 3/26/2012 13:51'!
toUtf8
	self blog ifNil: [ ^ self ].
	self blog toUtf8! !

GRObject subclass: #TFRssReaderFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFRssReaderFactory class methodsFor: 'factory instance creation' stamp: 'NickAger 3/27/2012 07:15'!
fromUrl: aUrlString
	"RSS: 	TFRssReaderFactory fromUrl: 'http://weeklysqueak.wordpress.com/feed/'"
	"ATOM:	TFRssReaderFactory fromUrl: 'http://code.google.com/feeds/p/seaside/issueupdates/basic'"
	| feedString |
	feedString := (ZnEasy get: aUrlString) contents.
	feedString isNil ifTrue: [ ^ nil ].
	
	^ self fromXml: feedString! !

!TFRssReaderFactory class methodsFor: 'factory instance creation' stamp: 'NickAger 3/26/2012 13:58'!
fromXml: aString
	| instance |
	instance := TFRss fromXml: aString.
	instance isNil 
		ifTrue: [ instance := TFAtomBlog fromXml: aString ].
		
	instance notNil 
		ifTrue: [ instance toUtf8 ].
	
	^ instance! !

Error subclass: #TFCreationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TopFeeder-Model'!

!TFCreationException methodsFor: 'testing' stamp: 'pmm 7/4/2007 20:19'!
isResumable
	^false! !
